/*
 * Copyright (c) 2014 by ELECTRONIC ASSEMBLY <technik@lcd-module.de>
 * EA DOG Graphic (ST7565R) software library for arduino.
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of either the GNU General Public License version 2
 * or the GNU Lesser General Public License version 2.1, both as
 * published by the Free Software Foundation.
 */

#ifndef DOG_H
#define DOG_H


#define DOGS102 1

#define VIEW_BOTTOM 0xC0
#define VIEW_TOP    0xC8

#define XPIXEL 102
#define YPIXEL 64


class dog
{
  private:
    
    byte disp_ram[XPIXEL * (YPIXEL/8)];
  
    byte p_cs;
    byte p_si;
    byte p_clk;
    byte p_a0;
    byte type;
    byte led;
    boolean top_view;
    boolean hardware; 
    boolean disp_update;   
	
    void DrawLine_1_5       (byte xs, byte xe, byte y);
    void DrawLine_3_7       (byte ys, byte ye, byte x);
    void DrawLine_2_8_flat  (byte xs, byte ys, byte xe, byte ye);
    void DrawLine_2_8_steep (byte xs, byte ys, byte xe, byte ye);
    void SetPixel           (byte x, byte y);
    void position       (byte column, byte page);
    void command	(byte dat);
    void data		(byte dat);
    
    void spi_initialize	(byte cs, byte si, byte clk);
    void spi_put_byte	(byte dat);
    void spi_put	(byte *dat, int len);
    void spi_out	(byte dat);

  public:   
    void initialize     (byte p_cs, byte p_si, byte p_clk, byte p_a0, byte p_res, byte type, byte led);
    void backlight      (byte brightness);
    void clear		      (void);
    void clear          (byte xs, byte ys, byte xe, byte ye);
    void invert         (byte xs, byte ys, byte xe, byte ye);
    void contrast       (byte contr);
    void view	          (byte direction);
    void string         (byte x, byte y, const byte *font_adress, const char *str);
    void line           (byte xs, byte ys, byte xe, byte ye);
    void rectangle	    (byte xs, byte ys, byte xe, byte ye);
    void picture	      (byte x, byte y, const byte *pic_adress);
    void update         (void);
};

#endif
